/*****************************************************************************/
/*
                                  AJPv12.c

Apache JServ Protocol version 1.2 for WASD.

Developed and tested against CPQ AXPVMS CSWS_JAVA V1.1 (May 14, 2002).
  

-------------------------------------------------------------------------------
-EXPERIMENTAL-EXPERIMENTAL-EXPERIMENTAL-EXPERIMENTAL-EXPERIMENTAL-EXPERIMENTAL-
-------------------------------------------------------------------------------

This package is *very experimental*.  Basically I have little idea what I'm
doing here and no time to learn JSERV or JSP (even though I know they would be
valuable skills for me to have).  The package is also *very basic*.  I'm not
quite sure of where to go next and would like some input from someone who has a
better idea about all of this.

DON'T BOTHER PLAYING WITH THIS PACKAGE UNLESS YOU'RE INTERESTED IN DOING
DEVELOPMENT WORK ON IT AND CONTRIBUTING THAT BACK INTO THE WASD DISTRIBUTION!
... it's not ready for production or even BETA testing - yet!

These would be helpful:

1)  Obviously deficiencies or bugs with the WASD implementation of the
    AJP v1.2 interface protocol (AJPV12.C).

2)  Documentation/guidelines for installing and configuring Tomcat for a
    WASD installation (with or without CSWS also on the system).

3)  Documentation/guidelines for configuring WASD for Tomcat.

4)  A WASD-specific examples page (perhaps an adaption of the Tomcat one).

5)  General comments and suggestions.

Thanks.


TOMCAT INSTALLATION FOR WASD
----------------------------
This assumes you already have Java 1.3.1 for OpenVMS installed.
The Tomcat package needs to be obtained from the OpenVMS site.

  http://www.openvms.compaq.com/openvms/products/ips/apache/csws_java.html

I should imagine that an existing installed-for-Apache Tomcat package could be
used to experiment with it from WASD.  This note assumes that you'll be getting
the package in especially for a WASD experiment.

Using CPQ-AXPVMS-CSWS_JAVA-V0101-1.PCSI

  $ PRODUCT INSTALL CSWS_JAVA /DESTINATION=HT_ROOT:[SRC]

When the installation is complete it should look like this:

  $ DIRECTORY HT_ROOT:[SRC.APACHE]

  Directory HT_ROOT:[SRC.APACHE]

  JAKARTA.DIR;1              1   3-JUL-2002 11:47:27.34
  JSERV.DIR;1                2   3-JUL-2002 11:47:47.16

  Total of 2 files, 3 blocks.

Then configure the installation using:

  $ @SYS$MANAGER:APACHE$JAKARTA_CONFIG

       CSWS Jakarta Configuration Menu

       Configuration Options:

            1 - Change Username
            2 - Add ACL to Jakarta (Tomcat) directories
            3 - Configure Apache's httpd.conf for Jakarta Adapters

            6 - View current configuration
            7 - Start CSWS Jakarta (Tomcat) for OpenVMS
            8 - Stop  CSWS Jakarta (Tomcat) for OpenVMS

            S - Save Configuration
           [E]- Exit Configuration procedure

  Enter configuration option:  Exit

Only item '2' and then item 'S' should be necessary for WASD (at least
initially)  because we'll be running the Java server by hand.


AJPv12/WASD SETUP FOR APACHE JSERV
----------------------------------
The following server configuration need to be made.

  # HTTPD$CONFIG
  [AddType]
  .jsp  text/jsp  JServ servlet pages
  [DclScriptRunTime]
  .jsp $HT_EXE:AJPV12.EXE

  # HTTPD$MAP
  exec /examples/*.jsp* /ht_root/src/apache/jakarta/webapps/examples/*.jsp* 
  pass /examples/* /device/apache/jakarta/webapps/examples/*

The AJPV12.EXE RTE interface can have some runtime characteristics tailored:

  AJPV12_SERVER_ADDRESS   This system logical name can be used to specify
                          the IP address of the system the APACHE$JAKARTA
                          server is executing on (defaults to 127.0.0.1,
                          i.e. local address for the same host).

  AJPV12_SERVER_PORT      IP port of Java server (defaults to 8007)
  

JAKARTA SETUP FOR WASD
----------------------
Running Tomcat interactively

  $ @SYS$COMMON:[SYSMGR]APACHE$JAKARTA RUN
  -> Tomcat Directory /$3$dkc600/apache/jakarta/
  Using Java 1.3.0 setup
  Setting up symbols for foreign command line usage...
  JAVA$FILENAME_CONTROLS now set to: -1
  Running Tomcat.....
  Starting tomcat. Check logs/tomcat.log for error messages
  2002-08-07 09:57:01 - ContextManager: Adding context Ctx( /examples )
  2002-08-07 09:57:01 - ContextManager: Adding context Ctx( /admin )
  2002-08-07 09:57:01 - ContextManager: Adding context Ctx(  )
  2002-08-07 09:57:01 - ContextManager: Adding context Ctx( /root )
  2002-08-07 09:57:01 - ContextManager: Adding context Ctx( /test )
  2002-08-07 09:57:05 - PoolTcpConnector: Starting HttpConnectionHandler on 8080
  2002-08-07 09:57:05 - PoolTcpConnector: Starting Ajp12ConnectionHandler on 8007


ACCESSING THE BASICS
--------------------
When the AJPV12 image is built, WASD configured, and Tomcat installed,
configured and running interactively then using a browser access

  http://the.host.name/examples/

Which should give you a directory listing of
HT_ROOT:[SRC.APACHE.EXAMPLES.JAKARTA.WEBAPPS.EXAMPLES] that looks something
like

  Index of  /examples/

         Name                           Revised         Size  Description

  [DIR]  ../                                                  parent directory
  [DIR]  images/               3-Jul-2002 13:59          512  subdirectory
  [DIR]  jsp/                  3-Jul-2002 13:59          512  subdirectory
  [DIR]  meta-inf/             3-Jul-2002 13:59          512  subdirectory
  [DIR]  servlets/             3-Jul-2002 13:59          512  subdirectory
  [DIR]  web-inf/              3-Jul-2002 13:59          512  subdirectory

Select the 'jsp/' subdirectory ([.JSP]) and a page of example servlets should
be available.  Selecting execute for any of these should activate the example. 
Initial activation can be a bit slow (even on a 500MHz system).

For example, activating the 'Numberguess' JSP servlet should provide an initial
page something like

  Welcome to the Number Guess game.
  I'm thinking of a number between 1 and 100.
  What's your guess? [      ] |submit|

(this is just a kind of proof that I have got it going ;^)

GOOD LUCK!
----------


V1.2 PROTOCOL
-------------
*** THIS DOES NOT APPEAR TO BE EXPLICITLY DOCUMENTED ANYWHERE!! ***
... so this is a best-guess, reverse-engineered attempt!

Some of this comes from JSERVAJPV12.C and some from JSERVCONNECTION.JAVA.

Each request header line has a two byte binary length (network byte order)
prepended to the string that is the data.  If a particular entity doesn't
exist (e.g. is NULL) then return 0xffff.

"Markers" seem to provide way-points in the protocol.
These seem to be single byte sentinals.

  0x00 ... NOP (stream OK?)
  0x01 ... start of META-data
           then expects as a series of record in order;
           method, servlet zone, servlet name, hostname
           DOCUMENT_ROOT, PATH_INFO, PATH_TRANSLATED, QUERY_STRING,
           REMOTE_ADDR, REMOTE_HOST, REMOTE_USER, AUTH_TYPE,
           REMOTE_PORT, REQUEST_METHOD, REQUEST_URI, SCRIPT_FILENAME,
           SCRIPT_NAME, SERVER_NAME, SERVER_PORT, SERVER_PROTOCOL,
           SERVER_SIGNATURE, SERVER_SOFTWARE, JSERV_ROUTE,
           *then* two throw-aways!
  0x02 ... ?
  0x03 ... a header string, each with a preceding 0x03 (v1.1 'H' records)
  0x04 ... end of META-data
  0x05 ... optional variables, each with a preceding 0x05 
  0xfe ... signals (v1.1 'S' records)
  0xff ... end of META-data


LOGICAL NAMES (or symbols)
-------------
AJPV12$DBUG             turns on all "if (dbug)" statements
AJPV12_SERVER_ADDRESS   IP address of Java server
AJPV12_SERVER_PORT      IP port of Java server


BUILD DETAILS
-------------
$ @BUILD_AJPV12 BUILD  !compile+link
$ @BUILD_AJPV12 LINK   !link-only


VERSION HISTORY (update SOFTWAREID as well!)
---------------
08-AUG-2002  MGD  v0.1.1, initial please-help-me-out-I'm-stuck release
23-FEB-2002  MGD  v0.1.0, initial development
*/
/*****************************************************************************/

#define AJPV12V "0.1.1"
#ifdef __ALPHA
#  define SOFTWAREID "AJPV12 AXP-" AJPV12V
#else
   /*
      Yes I know Tomcat's only available Alpha, but there's no reason why
      an AJPV12 interface running on VAX can't access it on an adjacent Alpha!
   */
#  define SOFTWAREID "AJPV12 VAX-" AJPV12V
#endif

/************/
/* includes */
/************/

/* standard C header files */

#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unixio.h>

#include <in.h>
#include <inet.h>
#include <netdb.h>
#include <socket.h>

/* VMS-specific header files */

#include <descrip.h>
#include <ssdef.h>

/**********/
/* macros */                          
/**********/

#define FI_LI "AJPV12", __LINE__

/* maximum length of a meta-data string */
#define META_DATA_MAXLEN 4096
#define REQUEST_ENTITY_MAXBUF 4096
#define RESPONSE_MAXBUF 4096

#define AJPV12_SERVER_DEFAULT_ADDRESS "127.0.0.1"
#define AJPV12_SERVER_DEFAULT_PORT 8007

/******************/
/* global storage */
/******************/

/* change to 0 to remove all (dbug) code from executable */
#define DBUG 1
#if DBUG
int  dbug;
#else
#define dbug 0
#endif

int  ajpIpAddress,
     ajpPort,
     ajpSocket,
     ContentLength,
     IsCgiPlus,
     UsageCount;

char  *ajpIpAddressStringPtr,
      *CgiPlusEofPtr,
      *CgiPlusEotPtr,
      *CgiPlusEscPtr;

struct sockaddr_in  ajpAddress;

struct hostent  *ajpHostEntPtr;

/**************/
/* prototypes */
/**************/

char* CgiVar (char*);
unsigned int lib$get_symbol (void*, void*, unsigned short*, unsigned long*);
void ProcessRequest ();
int ProvideMetaData ();
void ReportProblem (char*, char*, int);
int RequestEntity ();
int WriteMetaData (char*, char*);

/*****************************************************************************/
/*
*/

main (int argc, char *argv[])
       
{
   /*********/
   /* begin */
   /*********/

#if DBUG
   if (dbug = ((getenv ("AJPV12$DBUG")) != NULL))
      fprintf (stdout, "Content-Type: text/plain\n\n");
#endif

   /* if it doesn't look like CGI environment then forget it */
   if (!getenv ("HTTP$INPUT")) exit (SS$_ABORT);

   if (!dbug)
   {
      /* binary mode to eliminate carriage-control */
      if (!(stdin = freopen ("HTTP$INPUT:", "r", stdin, "ctx=bin")))
         exit (vaxc$errno);
      if (!(stdout = freopen ("SYS$OUTPUT:", "w", stdout, "ctx=bin")))
         exit (vaxc$errno);
      if (!(stderr = freopen ("SYS$OUTPUT:", "w", stderr, "ctx=bin")))
         exit (vaxc$errno);
   }

   IsCgiPlus = ((CgiPlusEofPtr = getenv("CGIPLUSEOF")) != NULL);
   CgiPlusEotPtr = getenv("CGIPLUSEOT");
   CgiPlusEscPtr = getenv("CGIPLUSESC");

   if (IsCgiPlus)
   {
      for (;;)
      {
         if (dbug) fprintf (stdout, "Content-Type: text/plain\n\n");
         /* block waiting for the first/next request */
         CgiVar ("");
         ProcessRequest ();
         fflush (stdout);
         fputs (CgiPlusEofPtr, stdout);
         fflush (stdout);
      }
   }
   else
   {
      if (dbug) fprintf (stdout, "Content-Type: text/plain\n\n");
      ProcessRequest ();
   }
}

/*****************************************************************************/
/*
Process a single CGI/CGIplus/RTE request.
All request processing occurs within this function.
*/

void ProcessRequest ()
       
{
   int  retval, status;
   char  *cptr;
   char  ResponseBuffer [RESPONSE_MAXBUF];

   /*********/
   /* begin */
   /*********/

   if (dbug) fprintf (stdout, "ProcessRequest()\n");

   UsageCount++;

   /***********************/
   /* open AJP connection */
   /***********************/

   if (!(ajpIpAddressStringPtr = getenv("AJPV12_SERVER_ADDRESS")))
      ajpIpAddressStringPtr = AJPV12_SERVER_DEFAULT_ADDRESS;

   if (cptr = getenv("AJPV12_SERVER_PORT"))
      ajpPort = atoi(cptr);
   if (!ajpPort) ajpPort = AJPV12_SERVER_DEFAULT_PORT;

   memset (&ajpAddress, 0, sizeof(ajpAddress));
   ajpAddress.sin_family = AF_INET;
   ajpAddress.sin_port = htons(ajpPort);

   ajpIpAddress = inet_addr (ajpIpAddressStringPtr);
   if (ajpIpAddress == INADDR_NONE)
   {
      ajpHostEntPtr = gethostbyname (ajpIpAddressStringPtr);
      if (!ajpHostEntPtr)
      {
         ReportProblem (strerror(errno), FI_LI);
         if (dbug) fprintf (stdout, "gethostbyname() %%X%08.08X\n", vaxc$errno);
         exit (SS$_NORMAL);
      }
      memcpy (&ajpIpAddress, ajpHostEntPtr->h_addr, sizeof(ajpIpAddress));
   }
   memcpy (&ajpAddress.sin_addr, &ajpIpAddress, sizeof(struct in_addr));

   ajpSocket = socket (AF_INET, SOCK_STREAM, 0);
   if (ajpSocket < 0)
   {
      ReportProblem (strerror(errno), FI_LI);
      if (dbug) fprintf (stdout, "socket() %%X%08.08X\n", vaxc$errno);
      exit (SS$_NORMAL);
   }

   retval = connect (ajpSocket, (struct sockaddr*)&ajpAddress, 
                     sizeof(ajpAddress));
   if (retval < 0)
   {
      ReportProblem (strerror(errno), FI_LI);
      if (dbug) fprintf (stdout, "connect() %%X%08.08X\n", vaxc$errno);
      exit (SS$_NORMAL);
   }

   /***********************/
   /* write AJP META data */
   /***********************/

   /* write the environment META-data */
   retval = ProvideMetaData ();
   if (retval < 0)
   {
      exit (SS$_NORMAL);
   }

   /************************/
   /* read response header */
   /************************/

   for (;;)
   {
      retval = recv (ajpSocket, ResponseBuffer, sizeof(ResponseBuffer)-1, 0);
      if (retval <= 0)
      {
         ReportProblem (strerror(errno), FI_LI);
         if (dbug) fprintf (stdout, "recv() %%X%08.08X\n", vaxc$errno);
         exit (SS$_NORMAL);
      }
      ResponseBuffer[retval] = '\0';
      fputs (ResponseBuffer, stdout);
      cptr = ResponseBuffer;
      while (*cptr)
      {
         while (*cptr && *cptr != '\r' && *cptr != '\n') cptr++;
         if (!*cptr) break;
         if (*(unsigned short*)cptr == '\n\n') break;
         if (*(unsigned long*)cptr == '\r\n\r\n') break;
         cptr++;
      }
   }

   /******************************/
   /* read (any) response entity */
   /******************************/

   for (;;)
   {
      retval = recv (ajpSocket, ResponseBuffer, sizeof(ResponseBuffer)-1, 0);
      if (retval <= 0) break;
      fwrite (ResponseBuffer, retval, 1, stdout);
   }

   /***********************/
   /* close AJP connection */
   /***********************/

   retval = shutdown (ajpSocket, 2);
   if (retval < 0)
   {
      ReportProblem (strerror(errno), FI_LI);
      if (dbug) fprintf (stdout, "shutdown() %%X%08.08X\n", vaxc$errno);
      exit (SS$_NORMAL);
   }

   retval = close (ajpSocket);
   if (retval < 0)
   {
      ReportProblem (strerror(errno), FI_LI);
      if (dbug) fprintf (stdout, "close() %%X%08.08X\n", vaxc$errno);
      exit (SS$_NORMAL);
   }
}

/*****************************************************************************/
/*
Write an AJP v1.2 request META-data record.
*/

int WriteMetaData
(
char *Name,
char *Value
)
{
   static unsigned short  allFs = 0xffff;

   int  cnt, len, retval;
   char  *cptr, *sptr, *zptr;
   char  Buffer [META_DATA_MAXLEN];

   /*********/
   /* begin */
   /*********/

   if (dbug) fprintf (stdout, "WriteMetaData()\n");

   if (!Name && !Value)
   {
      /* nothing at all */
      if (dbug) fprintf (stdout, "null string 0xffff\n");
      retval = send (ajpSocket, &allFs, 2, 0);
      return (retval);
   }

   if (!Value)
   {
      /* a marker */
      if (dbug) fprintf (stdout, "marker 0x%02.02x\n", (int)Name[0]);
      retval = send (ajpSocket, Name, 1, 0);
      return (retval);
   }

   retval = 0;
   if (Name)
   {
      zptr = (sptr = Buffer) + sizeof(Buffer);
      sptr += 2;
      for (cptr = Name; *cptr && sptr < zptr; *sptr++ = *cptr++);
      if (sptr >= zptr) return (-1);
      len = (sptr - Buffer) - 2;
      Buffer[0] = (len >> 8) & 0xff;
      Buffer[1] = len & 0xff;
      if (dbug) fprintf (stdout, "name 0x%04.04x |%s|\n", len, Name);
      retval = send (ajpSocket, Buffer, len+2, 0);
   }
   if (Value && retval >= 0)
   {
      zptr = (sptr = Buffer) + sizeof(Buffer);
      sptr += 2;
      for (cptr = Value; *cptr && sptr < zptr; *sptr++ = *cptr++);
      if (sptr >= zptr) return (-1);
      len = (sptr - Buffer) - 2;
      Buffer[0] = (len >> 8) & 0xff;
      Buffer[1] = len & 0xff;
      if (dbug) fprintf (stdout, "Value 0x%04.04x |%s|\n", len, Value);
      retval = send (ajpSocket, Buffer, len+2, 0);
   }

   if (dbug) fprintf (stdout, "%%X%08.08X\n", vaxc$errno);
   return (retval);
}

/*****************************************************************************/
/*
*/

int ProvideMetaData ()

{
   static char  *EnvironmentVars [] = {
"DOCUMENT_ROOT", "PATH_INFO", "PATH_TRANSLATED", "QUERY_STRING",
"REMOTE_ADDR", "REMOTE_HOST", "REMOTE_USER", "AUTH_TYPE",
"REMOTE_PORT", "REQUEST_METHOD", "REQUEST_URI", "SCRIPT_FILENAME",
"SCRIPT_NAME", "SERVER_NAME", "SERVER_PORT", "SERVER_PROTOCOL",
"SERVER_SIGNATURE", "SERVER_SOFTWARE",
NULL };

   static char  *header [] = {
"CONTENT_LENGTH", "Content-Length",
"CONTENT_TYPE", "Content-Type",
"HTTP_ACCEPT", "Accept",
"HTTP_ACCEPT_CHARSET", "Accept-Charset",
"HTTP_ACCEPT_ENCODING",  "Accept-Encoding",
"HTTP_ACCEPT_LANGUAGE", "Accept-Language",
"HTTP_AUTHORIZATION", "Authorization",
"HTTP_CACHE_CONTROL", "Cache-Control",
"HTTP_COOKIE", "Cookie",
"HTTP_FORWARDED", "Forwarded",
"HTTP_HOST", "Host",
"HTTP_IF_NOT_MODIFIED", "If-Not-Modified-Since",
"HTTP_PRAGMA", "Pragma",
"HTTP_REFERER", "Referer",
"HTTP_USER_AGENT", "User-Agent",
NULL };

   static char  *additional [] = {
NULL };

   static char  *cgi_var_names [] = {
"AUTH_ACCESS", "AUTH_AGENT", "AUTH_GROUP", "AUTH_PASSWORD",
"AUTH_REALM", "AUTH_REALM_DESCRIPTION", "AUTH_REMOTE_USER",
"AUTH_TYPE", "AUTH_USER",  "CONTENT_LENGTH", "CONTENT_TYPE",
"DOCUMENT_ROOT", "GATEWAY_BG", "GATEWAY_INTERFACE", "GATEWAY_MRS",
"PATH_INFO", "PATH_ODS", "PATH_TRANSLATED", "QUERY_STRING",
"REMOTE_ADDR", "REMOTE_HOST", "REMOTE_PORT", "REMOTE_USER", 
"REQUEST_METHOD", "REQUEST_SCHEME", "REQUEST_TIME_LOCAL", "REQUEST_TIME_GMT", 
"REQUEST_URI", "SCRIPT_FILENAME", "SCRIPT_NAME", "SERVER_ADMIN",
"SERVER_ADDR", "SERVER_CHARSET", "SERVER_GMT", "SERVER_NAME",
"SERVER_SOFTWARE", "SERVER_PROTOCOL", "SERVER_PORT", "SERVER_SIGNATURE",
"UNIQUE_ID",NULL };

   static char  *cgi_modssl_names [] = {
"HTTPS", "SSL_PROTOCOL", "SSL_SESSION_ID", "SSL_CIPHER", "SSL_CIPHER_EXPORT",
"SSL_CIPHER_USEKEYSIZE", "SSL_CIPHER_ALGKEYSIZE", "SSL_CLIENT_M_VERSION",
"SSL_CLIENT_M_SERIAL", "SSL_CLIENT_S_DN", "SSL_CLIENT_S_DN_x509",
"SSL_CLIENT_I_DN", "SSL_CLIENT_I_DN_x509", "SSL_CLIENT_V_START",
"SSL_CLIENT_V_END", "SSL_CLIENT_A_SIG", "SSL_CLIENT_A_KEY", "SSL_CLIENT_CERT",
"SSL_SERVER_M_VERSION", "SSL_SERVER_M_SERIAL", "SSL_SERVER_S_DN",
"SSL_SERVER_S_DN_x509", "SSL_SERVER_I_DN", "SSL_SERVER_I_DN_x509",
"SSL_SERVER_V_START", "SSL_SERVER_V_END", "SSL_SERVER_A_SIG",
"SSL_SERVER_A_KEY", "SSL_SERVER_CERT", "SSL_VERSION_INTERFACE",
"SSL_VERSION_LIBRARY", NULL };

   static char  *cgi_purveyor_names [] = {
"SECURITY_STATUS", "SSL_CIPHER", "SSL_CIPHER_KEYSIZE", "SSL_CLIENT_CA",
"SSL_CLIENT_DN", "SSL_SERVER_CA", "SSL_SERVER_DN", "SSL_VERSION", NULL };

   static char  *cgi_x509_names [] = {
"AUTH_X509_CIPHER", "AUTH_X509_FINGERPRINT", "AUTH_X509_ISSUER",
"AUTH_X509_KEYSIZE", "AUTH_X509_SUBJECT", NULL };

   int  idx, retval,
        MethodGet;
   char  *cptr, *sptr;
   
   /*********/
   /* begin */
   /*********/

   if (dbug) fprintf (stdout, "ProvideMetaData()\n");

   /* write the start-of-environment marker */
   retval = WriteMetaData ("\1", NULL);
   if (retval < 0) return (retval);

   sptr = CgiVar ("REQUEST_METHOD");
   if (!strcmp (sptr, "GET"))
      MethodGet = 1;
   else
      MethodGet = 0;
   retval = WriteMetaData (NULL, sptr);
   if (retval < 0) return (retval);

   sptr = "";
   retval = WriteMetaData (NULL, sptr);
   if (retval < 0) return (retval);

   /* servlet name */
   if (IsCgiPlus)
      sptr = CgiVar ("SCRIPT_NAME");
   else
      sptr = CgiVar ("PATH_INFO");
   retval = WriteMetaData (NULL, sptr);
   if (retval < 0) return (retval);

   sptr = CgiVar ("SERVER_NAME");
   retval = WriteMetaData (NULL, sptr);
   if (retval < 0) return (retval);

   for (idx = 0; cptr = EnvironmentVars[idx]; idx++)
   {
      if (!(sptr = CgiVar (cptr))) continue;
      retval = WriteMetaData (NULL, sptr);
      if (retval < 0) return (retval);
   }

   /* jserv_route, whate'r that may be */
   sptr = "";
   retval = WriteMetaData (NULL, sptr);
   if (retval < 0) return (retval);

   /* a couple of empty strings (they're in jservconnection.java!) */
   retval = WriteMetaData ("", "");
   if (retval < 0) return (retval);

   for (idx = 0; cptr = header[idx]; idx++)
   {
      idx++;
      if (!(sptr = CgiVar (cptr))) continue;
      if (!strcmp (cptr, "CONTENT_LENGTH") && *(unsigned short*)sptr == '0\0')
         continue;
      if (!strcmp (cptr, "CONTENT_TYPE") && MethodGet)
         continue;
      cptr = header[idx];
      /* write header marker */
      retval = WriteMetaData ("\3", NULL);
      if (retval < 0) return (retval);
      retval = WriteMetaData (cptr, sptr);
      if (retval < 0) return (retval);
   }

#ifdef BLAH
   /* Apache mod_ssl-like SSL CGI variables */
   if (CgiVar ("SSL_VERSION_INTERFACE"))
   {
      for (idx = 0; cptr = cgi_modssl_names[idx]; idx++)
      {
         if (!(sptr = CgiVar (cptr))) continue;
         /* write additional marker */
         retval = WriteMetaData ("\5", NULL);
         if (retval < 0) return (retval);
         retval = WriteMetaData (cptr, sptr);
         if (retval < 0) return (retval);
      }
   }
   
   /* Purveyor-like SSL CGI variables */
   if (CgiVar ("SECURITY_STATUS"))
   {
      for (idx = 0; cptr = cgi_purveyor_names[idx]; idx++)
      {
         if (!(sptr = CgiVar (cptr))) continue;
         /* write the start-of-additional marker */
         retval = WriteMetaData ("\5", NULL);
         if (retval < 0) return (retval);
         retval = WriteMetaData (cptr, sptr);
         if (retval < 0) return (retval);
      }
   }
   
   /* X.509 client certificate authentication CGI variables */
   if (CgiVar ("AUTH_X509_CIPHER"))
   {
      for (idx = 0; cptr = cgi_x509_names[idx]; idx++)
      {
         if (!(sptr = CgiVar (cptr))) continue;
         /* write the start-of-additional marker */
         retval = WriteMetaData ("\5", NULL);
         if (retval < 0) return (retval);
         retval = WriteMetaData (cptr, sptr);
         if (retval < 0) return (retval);
      }
   }
#endif

   /* write the end-of-META-data marker */
   retval = WriteMetaData ("\4", NULL);
   if (retval < 0) return (retval);

   if (!(sptr = CgiVar ("CONTENT_LENGTH"))) return (-1);
   ContentLength = atoi(sptr);
   if (dbug) fprintf (stdout, "|%s| %d\n", sptr, ContentLength);
   if (ContentLength) retval = RequestEntity ();

   return (retval);
}

/*****************************************************************************/
/*
Return the value of a CGI variable regardless of whether it is used in a
standard CGI environment or a WASD CGIplus (RTE) environment.  Also
automatically switches WASD V7.2 and later servers into 'struct' mode for
significantly improved performance.

WASD by default supplies CGI variables prefixed by "WWW_" to differentiate them
from any other DCL symbols (or "env"ironment logicals).
*/

char* CgiVar (char *VarName)

{
#  ifndef CGIVAR_STRUCT_SIZE
#     define CGIVAR_STRUCT_SIZE 8192
#  endif
#  define SOUS sizeof(unsigned short)

   static int  CalloutDone,
               StructLength;
   static char  *NextVarNamePtr;
   static char  StructBuffer [CGIVAR_STRUCT_SIZE];
   static FILE  *CgiPlusIn;
   
   int  status;
   int  Length;
   char  *bptr, *cptr, *sptr;

   /*********/
   /* begin */
   /*********/

   if (dbug)
      fprintf (stdout, "CgiVar() |%s|\n", !VarName ? "NULL" : VarName);

   if (!VarName || !VarName[0])
   {
      /* initialize */
      StructLength = 0;
      NextVarNamePtr = StructBuffer;
      if (!VarName) return (NULL);
   }

   if (VarName[0])
   {
      /***************************/
      /* return a variable value */
      /***************************/

      if (!IsCgiPlus)
      {
         /* standard CGI environment */
         static char  WwwName [256] = "WWW_";
         static $DESCRIPTOR (NameDsc, WwwName);
         static $DESCRIPTOR (ValueDsc, "");
         unsigned short  ShortLength;
         char  Value [1024];

         /* by default WASD CGI variable names are prefixed by "WWW_", add */
         strncpy (WwwName+4, VarName, sizeof(WwwName)-5);
         NameDsc.dsc$w_length = strlen(WwwName);
         ValueDsc.dsc$a_pointer = Value;
         ValueDsc.dsc$w_length = 1023;
   
         status = lib$get_symbol (&NameDsc, &ValueDsc, &ShortLength, NULL);
         if (status & 1)
         {
            cptr = malloc (ShortLength+1);
            memcpy (cptr, Value, ShortLength);
            cptr[ShortLength] = '\0';
         }
         else
            cptr = NULL;

         if (dbug) fprintf (stdout, "CGI |%s|\n", !cptr ? "NULL" : cptr);
         return (cptr);
      }

      /* hmmm, CGIplus not initialized */
      if (!StructLength) return (NULL);

      if (VarName[0] == '*')
      {
         /* return each CGIplus variable in successive calls */
         if (!(Length = *(unsigned short*)NextVarNamePtr))
         {
            NextVarNamePtr = StructBuffer;
            if (dbug) fprintf (stdout, "CGIplus |NULL|\n");
            return (NULL);
         }
         sptr = (NextVarNamePtr += SOUS);
         NextVarNamePtr += Length;
         if (dbug) fprintf (stdout, "CGIplus |%s|\n", sptr);
         /* by default WASD CGI variable name are prefixed by "WWW_", ignore */
         return (sptr + 4);
      }

      /* return a pointer to this CGIplus variable's value */
      for (bptr = StructBuffer; Length = *(unsigned short*)bptr; bptr += Length)
      {
         /* by default WASD CGI variable name are prefixed by "WWW_", ignore */
         sptr = (bptr += SOUS) + 4;
         for (cptr = VarName; *cptr && *sptr && *sptr != '='; cptr++, sptr++)
            if (toupper(*cptr) != toupper(*sptr)) break;
         /* if found return a pointer to the value */
         if (!*cptr && *sptr == '=')
         {
            if (dbug) fprintf (stdout, "CGIplus |%s|\n", sptr+1);
            cptr = malloc (strlen(sptr));
            strcpy (cptr, sptr+1);
            return (cptr);
         }
      }
      /* not found */
      if (dbug) fprintf (stdout, "CGIplus |NULL|\n");
      return (NULL);
   }

   /*****************************/
   /* get the CGIplus variables */
   /*****************************/

   /* cannot "sync" in a non-CGIplus environment */
   if (!VarName[0] && !IsCgiPlus) return (NULL);

   /* the CGIPLUSIN stream can be left open */
   if (!CgiPlusIn)
      if (!(CgiPlusIn = fopen (getenv("CGIPLUSIN"), "r")))
         exit (vaxc$errno);

   /* get the starting record (the essentially discardable one) */
   for (;;)
   {
      cptr = fgets (StructBuffer, sizeof(StructBuffer), CgiPlusIn);
      if (!cptr) exit (vaxc$errno);
      /* if the starting sentinal is detected then break */
      if (*(unsigned short*)cptr == '!\0' ||
          *(unsigned short*)cptr == '!\n' ||
          (*(unsigned short*)cptr == '!!' && isdigit(*(cptr+2)))) break;
   }

   /* MUST be done after reading the synchronizing starting record */
   if (dbug) fprintf (stdout, "Content-Type: text/plain\n\n%s", StructBuffer);

   /* detect the CGIplus "force" record-mode environment variable (once) */
   if (*(unsigned short*)cptr == '!!')
   {
      /********************/
      /* CGIplus 'struct' */
      /********************/

      /* get the size of the binary structure */
      StructLength = atoi(cptr+2);
      if (StructLength <= 0 || StructLength > sizeof(StructBuffer))
         exit (SS$_BUGCHECK);

      if (!fread (StructBuffer, 1, StructLength, CgiPlusIn))
         exit (vaxc$errno);
   }
   else
   {
      /*********************/
      /* CGIplus 'records' */
      /*********************/

      /* reconstructs the original 'struct'ure from the records */
      sptr = (bptr = StructBuffer) + sizeof(StructBuffer);
      while (fgets (bptr+SOUS, sptr-(bptr+SOUS), CgiPlusIn))
      {
         /* first empty record (line) terminates variables */
         if (bptr[SOUS] == '\n') break;
         /* note the location of the length word */
         cptr = bptr;
         for (bptr += SOUS; *bptr && *bptr != '\n'; bptr++);
         if (*bptr != '\n') exit (SS$_BUGCHECK);
         *bptr++ = '\0';
         if (bptr >= sptr) exit (SS$_BUGCHECK);
         /* update the length word */
         *(unsigned short*)cptr = bptr - (cptr + SOUS);
      }
      if (bptr >= sptr) exit (SS$_BUGCHECK);
      /* terminate with a zero-length entry */
      *(unsigned short*)bptr = 0;
      StructLength = (bptr + SOUS) - StructBuffer;
   }

   if (dbug)
   {
      fprintf (stdout, "%d\n", StructLength);
      for (bptr = StructBuffer; Length = *(unsigned short*)bptr; bptr += Length)
         fprintf (stdout, "|%s|\n", bptr += SOUS);
   }

   if (!CalloutDone)
   {
      /* provide the CGI callout to set CGIplus into 'struct' mode */
      fflush (stdout);
      fputs (CgiPlusEscPtr, stdout);
      fflush (stdout);
      /* the leading '!' indicates we're not going to read the response */
      fputs ("!CGIPLUS: struct", stdout);
      fflush (stdout);
      fputs (CgiPlusEotPtr, stdout);
      fflush (stdout);
      /* don't need to do this again (the '!!' tells us what mode) */
      CalloutDone = 1;
   }

   return (NULL);

#  undef SOUS
}

/*****************************************************************************/
/*
Read the POSTed body from <stdin> (which with WASD is actually HTTP$INPUT).
*/

int RequestEntity ()

{
   int  retval,
        ContentCount;
   char  Buffer [REQUEST_ENTITY_MAXBUF];

   /*********/
   /* begin */
   /*********/

   if (dbug) fprintf (stdout, "RequestEntity()\n");

   ContentCount = 0;
   while (ContentCount < ContentLength)
   {
      retval = read (fileno(stdin), Buffer, sizeof(Buffer));
      if (retval <= 0) break;
      ContentCount += retval;
      if (dbug) fprintf (stdout, "%d\n", ContentCount);
      retval = send (ajpSocket, Buffer, retval, 0);
      if (retval <= 0) break;
   }
   return (ContentCount);
}

/*****************************************************************************/
/*
Provide a 502 error that looks like a standard WASD report.
*/

void ReportProblem
(
char *ProblemString,
char *SourceModule,
int SourceLine
)
{
   char  *cptr, *sptr, *zptr;
   char  StringBuffer [256];

   /*********/
   /* begin */
   /*********/

   if (dbug) fprintf (stdout, "ReportProblem() |%s|\n", ProblemString);

   /* mostly from strerror(), tidy it up a little */
   cptr = ProblemString;
   zptr = (sptr = StringBuffer) + sizeof(StringBuffer)-1;
   *sptr++ = toupper(*cptr++);
   while (*cptr && sptr < zptr) *sptr++ = *cptr++;
   if (sptr > StringBuffer) sptr--;
   while (sptr > StringBuffer && isspace(*sptr)) sptr--;
   if (sptr > StringBuffer && sptr < zptr) sptr++;
   if (sptr < zptr) *sptr++ = '.';
   *sptr = '\0';

   sptr = CgiVar ("SERVER_SIGNATURE");

   fprintf (stdout,
"Status: 502 Bad Gateway\r\n\
Content-Type: text/html\r\n\
\r\n\
<HTML>\n\
<HEAD>\n\
<META NAME=\"generator\" CONTENT=\"%s\">\n\
<META NAME=\"module\" CONTENT=\"%s\">\n\
<META NAME=\"line\" CONTENT=\"%d\">\n\
<TITLE>ERROR 502 Bad Gateway</TITLE>\n\
</HEAD>\n\
<BODY>\n\
<FONT SIZE=+1>\n\
<B>ERROR 502</B> &nbsp;-&nbsp; Bad gateway.\n\
</FONT>\n\
<P>%s\n\
<P><HR WIDTH=85%% ALIGN=left SIZE=2 NOSHADE>\n\
%s%s\
</BODY>\n\
</HTML>\n",
      SOFTWAREID, SourceModule, SourceLine,
      StringBuffer, sptr?sptr:"", sptr?"\n":"");

}

/*****************************************************************************/
